%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% 		  Lounis ADOUANE                                            %%
%% 		  Polytech'Clermont-Ferrand                                 %%   
%%        Dpartement Gnie Electrique (GE3)                        %%
%% 		  Novembre 2006                                             %%
%% 		  Simulation d'un robot de type SCARA 2D.                   %%
%%        TP Modlisation et Commande des Robots (AURO11)           %%
%%                                                                  %% 
%% Fonction qui dfinit le modle dynamique direct du robot SCARA   %%
%% 2dll, i.e.,  partir des couples appliqus par les actionneurs,  %%
%% permet d'obtenir les acclrations articulaires qpp du robot.    %% 
%% NB : cette fonction est appele par le modle Simulink           %%
%% SimulinkControleRobotSCARA_AvecMD.mdl via SimulationRobotSCARA.m.%%
%%                                                                  %%
%% Dernire mise  jour : Novembre 2010                             %%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function qpp=ModeleDynamiqueDirect(Donnees)

Gama = Donnees(1:2);
q = Donnees(3:4);
qp = Donnees(5:6);

%%Dfinitions des constantes qui sont fonction des longueurs des bras, de
%%leurs inerties (masses, moments d'inerties, etc.).
LMX2=1.254;
LMY2=0.98;
ZZR1=3.05;
ZZ2=1.01;

%%%%%%%%%%%%%%%%%%%%%%%%%%
%%Calcul de la matrice A %    
%%%%%%%%%%%%%%%%%%%%%%%%%%

A11=ZZR1+ZZ2+2*LMX2*cos(q(2))-2*LMY2*sin(q(2)); 
A12=ZZ2+LMX2*cos(q(2))-LMY2*sin(q(2));
A = [A11, A12; A12, ZZ2];

InvA = A\eye(2); 

Diff_G_H=[Gama(1)+(LMX2*sin(q(2))+LMY2*cos(q(2)))*(qp(2)*(qp(2)+2*qp(1)));
          Gama(2)-(LMX2*sin(q(2))+LMY2*cos(q(2)))*(qp(1)^2)];
     
qpp=InvA*Diff_G_H;

